#include "fetchingtablemodel.h"
#include <QDebug>

FetchingListModel::FetchingListModel(QObject *parent) : QAbstractListModel(parent)
{
    _requestTimer = new QTimer(this);
    _requestTimer->setSingleShot(true);
    connect(_requestTimer, &QTimer::timeout,
            this, &FetchingListModel::newDataReceived);

}

void FetchingListModel::newDataReceived()
{
    //Эмуляция добавления нового массива данных
    qDebug() << "New data received";
    beginInsertRows(QModelIndex(), _rowCount, _rowCount + 20);
    _rowCount += 20;
    endInsertRows();
}


int FetchingListModel::rowCount(const QModelIndex &parent) const
{
    return _rowCount;
}

QVariant FetchingListModel::data(const QModelIndex &index, int role) const
{
    if (!index.isValid())
        return QVariant();
    if (role == Qt::DisplayRole)
        return QString("Record %1").arg(index.row() + 1);
    return QVariant();
}

void FetchingListModel::fetchMore(const QModelIndex &parent)
{
    qDebug() << "Fetch more";
    //Эмуляция запроса данных
    _requestTimer->start(500);
}

bool FetchingListModel::canFetchMore(const QModelIndex &parent) const
{
    qDebug() << "Can fetch more";
    //Ограничение на суммарное количество загружаемых строк
    return rowCount() < 100;
}
