#ifndef FETCHINGTABLEMODEL_H
#define FETCHINGTABLEMODEL_H

#include <QAbstractTableModel>
#include <QTimer>

// Модель с загрузкой данных по частям
class FetchingListModel : public QAbstractListModel
{
    Q_OBJECT
public:
    FetchingListModel(QObject *parent = nullptr);
private:
    //Таймер для эмуляции запроса новых данных
    QTimer* _requestTimer;
    int _rowCount = 20;
private slots:
    void newDataReceived();

    // QAbstractItemModel interface
public:
    virtual int rowCount(const QModelIndex &parent = QModelIndex()) const override;
    virtual QVariant data(const QModelIndex &index, int role) const override;

    //Методы, которые необходимо переопределить для загрузки по частям

    //В методе должен быть реализован запрос новой части данных модели
    virtual void fetchMore(const QModelIndex &parent) override;
    //Метод определяет, есть ли данный для подгрузки
    virtual bool canFetchMore(const QModelIndex &parent) const override;
};



#endif // FETCHINGTABLEMODEL_H
